# Contributing to Neighbor.ly

We love pull requests!

To report a bug or simply help Neighbor.ly help communities, take a look through the following guide.

## Reporting bugs and opening issues

To report a bug or open an issue, please follow the steps below:

1. **Find the correct repository.** Neighbor.ly is split across multiple repositories, each containing a different service. If you know the bug only applies to one service/gem, please open an issue in that repository (a list is available [here](https://github.com/neighborly/neighborly#other-repositories)). For general bugs and issues that span more than one service/gem, please open an issue in the [neighborly/neighborly](https://github.com/neighborly/neighborly) repository.
2. **Check if there is an existing issue.** If an issues already exists, please add
   any more information that you have, or give it a "+1" in the comments.
3. **Make sure that is related to Neighbor.ly.** If you open an issue that is not related to Neighbor.ly (e.g. a problem associated with git) we will simply close it.

When submitting an issue please describe the issue as clearly as possible, including how to reproduce the bug, which situations it appears in, what you expected to happen, and what actually happened. Screenshots for front-end issues are also very helpful.

## Pull Requests

See [our guides](https://github.com/neighborly/guides) to get things done, programming well, and following our patterns. Make sure your code follows our [style guide](https://github.com/neighborly/guides/tree/master/style) as well.

Add tests for your changes. Only refactoring and documentation changes require no new tests. If you are adding functionality or fixing a bug, we need a test! **We will not accept pull requests of features without tests.**

Again, we love pull requests, so don't be afraid to go ahead and change something or add a new feature. If they make sense, we're happy to work with you to get your changes merged into Neighbor.ly .

If you have an idea for a change, please discuss it in the open first, either by opening an issue, or by joining us in our [development chat room](https://www.hipchat.com/gWUYj8qfh).

Looking for something to work on? Take a look at our [open issues](https://github.com/neighborly/neighborly/issues?state=open).

## Developer Chat Room

To ask a question in real-time or to get a feel for what's going on, please drop into our [development chat room](https://www.hipchat.com/gWUYj8qfh). If no one is online, you can still leave a message and we'll reply as soon as we return.

## Security

Please do not publish security vulnerabilities publicly until we've had a chance to address them. All security related issues/patches should be sent directly to security@neighbor.ly where we will attempt to address them quickly. If you're unsure whether something is a security issue or not, please be cautious and contact us at security@neighbor.ly first.


And in case we didn't emphasize it enough: **we love tests!**